import logging

import requests
from clients.parcelsapp import ParcelsAppClient

from . import http, secrets

logger = logging.getLogger(__name__)


def main():
    logging.basicConfig()
    logger.setLevel('INFO')

    parcelsapp_client: ParcelsAppClient = ParcelsAppClient(
        requests.Session(),
        parcels_api_key=secrets.PARCELS_API_KEY,
    )

    http.initialize_server(parcelsapp_client)


if __name__ == '__main__':
    main()
