# WARNING!
# THIS IS AN AUTOGENERATED FILE!
# MANUAL CHANGES CAN AND WILL BE OVERWRITTEN!

import re
from pathlib import Path

from setuptools import setup

PACKAGE_NAME = 'package_tracking'

PACKAGE_DESCRIPTION = """
# Package-tracking.

Small alternative frontend for tracking packages and parcels.

Use the excellent [Parcels App API](https://parcelsapp.com/), and thus requires
an API key.

This was written specifically for embedding as an iframe into homepage
applications like [Homepage](https://gethomepage.dev/) or [Dashy](https://dashy.to/).

Once run, it exposes the following endpoints:

- `/`: Base view, including a form for adding new parcels.
- `/noninteraction`: Smaller view for embedding as iframe.
""".strip()

PACKAGE_DESCRIPTION_SHORT = """
Small alternative frontend for tracking packages and parcels.""".strip()


def parse_version_file(text: str) -> str:
    text = re.sub('^#.*', '', text, flags=re.MULTILINE)
    match = re.match(r'^\s*__version__\s*=\s*(["\'])([\d\.]+)\1$', text)
    if match is None:
        msg = 'Malformed _version.py file!'
        raise Exception(msg)
    return match.group(2)


def find_python_packages() -> list[str]:
    """
    Find all python packages. (Directories containing __init__.py files.)
    """
    root_path = Path(PACKAGE_NAME)
    packages: set[str] = set([PACKAGE_NAME])

    # Search recursively
    for init_file in root_path.rglob('__init__.py'):
        packages.add(str(init_file.parent).replace('/', '.'))

    print(f'Found following packages: {packages}')
    return sorted(packages)

with open(PACKAGE_NAME + '/_version.py') as f:
    version = parse_version_file(f.read())


REQUIREMENTS_MAIN = [
    'bottle',
    'requests',
    'secret_loader @ git+https://gitfub.space/Jmaa/secret_loader',
    'clients @ git+https://gitfub.space/Jmaa/clients',
]
REQUIREMENTS_TEST = []


setup(
    name=PACKAGE_NAME,
    version=version,
    description=PACKAGE_DESCRIPTION_SHORT,
    long_description=PACKAGE_DESCRIPTION,
    long_description_content_type='text/markdown',
    author='Jon Michael Aanes',
    author_email='jonjmaa@gmail.com',
    url='https://gitfub.space/Jmaa/' + PACKAGE_NAME,
    packages=find_python_packages(),
    install_requires=REQUIREMENTS_MAIN,
    extras_require={
        'test': REQUIREMENTS_TEST,
    },
    python_requires='>=3.9',
)
